--Color Curves effect filter by khaver

obs = obslua

SETTING_ShadR = 'ShadR'
SETTING_ShadG = 'ShadG'
SETTING_ShadB = 'ShadB'
SETTING_ShadP = 'ShadP'
SETTING_MidR = 'MidR'
SETTING_MidG = 'MidG'
SETTING_MidB = 'MidB'
SETTING_MidP = 'MidP'
SETTING_HighR = 'HighR'
SETTING_HighG = 'HighG'
SETTING_HighB = 'HighB'
SETTING_HighP = 'HighP'
SETTING_SAT = 'SAT'
SETTING_PresLum = 'PresLum'
SETTING_graph = 'graph'

TEXT_ShadR = 'Shadow Cy<>Rd'
TEXT_ShadG = 'Shadow Mg<>Gr'
TEXT_ShadB = 'Shadow Yl<>Bl'
TEXT_ShadP = 'Shadow Point'
TEXT_MidR = 'Mid Cy<>Rd'
TEXT_MidG = 'Mid Mg<>Gr'
TEXT_MidB = 'Mid Yl<>Bl'
TEXT_MidP = 'Mid Point'
TEXT_HighR = 'High Cy<>Rd'
TEXT_HighG = 'High Mg<>Gr'
TEXT_HighB = 'High Yl<>Bl'
TEXT_HighP = 'High Point'
TEXT_SAT = 'Saturation Limiter'
TEXT_PresLum = 'Preserve Luma'
TEXT_graph = 'Graph'

source_info = {}
source_info.id = 'filter-colorcurves'
source_info.type = obs.OBS_SOURCE_TYPE_FILTER
source_info.output_flags = obs.OBS_SOURCE_VIDEO

-- Returns the description displayed in the Scripts window
function script_description()
  return [[
Color Curves - A color correction filter by khaver
]]
end

function set_render_size(filter)
    target = obs.obs_filter_get_target(filter.source)

    local width, height
    if target == nil then
        width = 0
        height = 0
    else
        width = obs.obs_source_get_base_width(target)
        height = obs.obs_source_get_base_height(target)
    end

    filter.width = width
    filter.height = height
end

function script_load(settings)
  obs.obs_register_source(source_info)
end

source_info.get_name = function()
    return "Color Curves"
end

source_info.create = function(settings, source)

    local filter = {}
    filter.source = source
	--filter.width = 1
	--filter.height = 1
	set_render_size(filter)
    obs.obs_enter_graphics()
    --local effect_path = script_path() .. 'filter-curves.effect'
    --filter.effect = obs.gs_effect_create_from_file(effect_path, nil)
	filter.effect = obs.gs_effect_create(shader, nil, nil)

	if filter.effect ~= nil then
		filter.params = {}
        filter.params.ShadR = obs.gs_effect_get_param_by_name(filter.effect, 'ShadR')
        filter.params.ShadG = obs.gs_effect_get_param_by_name(filter.effect, 'ShadG')
        filter.params.ShadB = obs.gs_effect_get_param_by_name(filter.effect, 'ShadB')
        filter.params.ShadP = obs.gs_effect_get_param_by_name(filter.effect, 'ShadP')
        filter.params.MidR = obs.gs_effect_get_param_by_name(filter.effect, 'MidR')
        filter.params.MidG = obs.gs_effect_get_param_by_name(filter.effect, 'MidG')
        filter.params.MidB = obs.gs_effect_get_param_by_name(filter.effect, 'MidB')
        filter.params.MidP = obs.gs_effect_get_param_by_name(filter.effect, 'MidP')
        filter.params.HighR = obs.gs_effect_get_param_by_name(filter.effect, 'HighR')
        filter.params.HighG = obs.gs_effect_get_param_by_name(filter.effect, 'HighG')
        filter.params.HighB = obs.gs_effect_get_param_by_name(filter.effect, 'HighB')
        filter.params.HighP = obs.gs_effect_get_param_by_name(filter.effect, 'HighP')
        filter.params.SAT = obs.gs_effect_get_param_by_name(filter.effect, 'SAT')
        filter.params.PresLum = obs.gs_effect_get_param_by_name(filter.effect, 'PresLum')
        filter.params.graph = obs.gs_effect_get_param_by_name(filter.effect, 'graph')
        filter.params.width = obs.gs_effect_get_param_by_name(filter.effect, 'width')
        filter.params.height = obs.gs_effect_get_param_by_name(filter.effect, 'height')
		--filter.params.time = obs.gs_effect_get_param_by_name(filter.effect, 'time')
	end
    obs.obs_leave_graphics()


    if filter.effect == nil then
        source_info.destroy(filter)
        return nil
    end

    source_info.update(filter, settings)
    return filter
end

source_info.destroy = function(filter)
    if filter.effect ~= nil then
        obs.obs_enter_graphics()
        obs.gs_effect_destroy(filter.effect)
		--filter.effect = nil
        obs.obs_leave_graphics()
    end
	filter = nil
end

source_info.get_width = function(filter)
    return filter.width
end

source_info.get_height = function(filter)
    return filter.height
end

source_info.get_properties = function(settings)
    props = obs.obs_properties_create()

    obs.obs_properties_add_bool(props, SETTING_graph, TEXT_graph)
    obs.obs_properties_add_bool(props, SETTING_PresLum, TEXT_PresLum)
    obs.obs_properties_add_float_slider(props, SETTING_HighP, TEXT_HighP, 161.0, 254.0, 1.0)
    obs.obs_properties_add_float_slider(props, SETTING_HighR, TEXT_HighR, -0.5, 0.5, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_HighG, TEXT_HighG, -0.5, 0.5, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_HighB, TEXT_HighB, -0.5, 0.5, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_MidP, TEXT_MidP, 97.0, 160.0, 1.0)
    obs.obs_properties_add_float_slider(props, SETTING_MidR, TEXT_MidR, -0.5, 0.5, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_MidG, TEXT_MidG, -0.5, 0.5, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_MidB, TEXT_MidB, -0.5, 0.5, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_ShadP, TEXT_ShadP, 1.0, 96.0, 1.0)
    obs.obs_properties_add_float_slider(props, SETTING_ShadR, TEXT_ShadR, -0.5, 0.5, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_ShadG, TEXT_ShadG, -0.5, 0.5, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_ShadB, TEXT_ShadB, -0.5, 0.5, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_SAT, TEXT_SAT, 0.0, 1.0, 0.001)

    return props
end

source_info.get_defaults = function(settings)
    obs.obs_data_set_default_double(settings, SETTING_ShadR, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_ShadG, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_ShadB, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_ShadP, 64.0)
    obs.obs_data_set_default_double(settings, SETTING_MidR, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_MidG, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_MidB, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_MidP, 128.0)
    obs.obs_data_set_default_double(settings, SETTING_HighR, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_HighG, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_HighB, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_HighP, 192.0)
    obs.obs_data_set_default_double(settings, SETTING_SAT, 1.0)
    obs.obs_data_set_default_bool(settings, SETTING_PresLum, false)
    obs.obs_data_set_default_bool(settings, SETTING_graph, false)
end

source_info.update = function(filter, settings)
    filter.ShadR = obs.obs_data_get_double(settings, SETTING_ShadR)
    filter.ShadG = obs.obs_data_get_double(settings, SETTING_ShadG)
    filter.ShadB = obs.obs_data_get_double(settings, SETTING_ShadB)
    filter.ShadP = obs.obs_data_get_double(settings, SETTING_ShadP)
    filter.MidR = obs.obs_data_get_double(settings, SETTING_MidR)
    filter.MidG = obs.obs_data_get_double(settings, SETTING_MidG)
    filter.MidB = obs.obs_data_get_double(settings, SETTING_MidB)
    filter.MidP = obs.obs_data_get_double(settings, SETTING_MidP)
    filter.HighR = obs.obs_data_get_double(settings, SETTING_HighR)
    filter.HighG = obs.obs_data_get_double(settings, SETTING_HighG)
    filter.HighB = obs.obs_data_get_double(settings, SETTING_HighB)
    filter.HighP = obs.obs_data_get_double(settings, SETTING_HighP)
    filter.SAT = obs.obs_data_get_double(settings, SETTING_SAT)
    filter.PresLum = obs.obs_data_get_bool(settings, SETTING_PresLum)
    filter.graph = obs.obs_data_get_bool(settings, SETTING_graph)

	--filter.settings = settings

	set_render_size(filter)

end

source_info.video_render = function(filter)

  if not obs.obs_source_process_filter_begin(filter.source, obs.GS_RGBA, obs.OBS_NO_DIRECT_RENDERING) then
	obs.obs_source_skip_video_filter(filter.source)
	return
  end

  --local parent = obs.obs_filter_get_parent(filter.source)
  --filter.width = obs.obs_source_get_base_width(parent)
  --filter.height = obs.obs_source_get_base_height(parent)
  --filter.time = os.clock()


    obs.gs_effect_set_float(filter.params.ShadR, filter.ShadR)
    obs.gs_effect_set_float(filter.params.ShadG, filter.ShadG)
    obs.gs_effect_set_float(filter.params.ShadB, filter.ShadB)
    obs.gs_effect_set_float(filter.params.ShadP, filter.ShadP)
    obs.gs_effect_set_float(filter.params.MidR, filter.MidR)
    obs.gs_effect_set_float(filter.params.MidG, filter.MidG)
    obs.gs_effect_set_float(filter.params.MidB, filter.MidB)
    obs.gs_effect_set_float(filter.params.MidP, filter.MidP)
    obs.gs_effect_set_float(filter.params.HighR, filter.HighR)
    obs.gs_effect_set_float(filter.params.HighG, filter.HighG)
    obs.gs_effect_set_float(filter.params.HighB, filter.HighB)
    obs.gs_effect_set_float(filter.params.HighP, filter.HighP)
    obs.gs_effect_set_float(filter.params.SAT, filter.SAT)
    obs.gs_effect_set_bool(filter.params.PresLum, filter.PresLum)
    obs.gs_effect_set_bool(filter.params.graph, filter.graph)
	obs.gs_effect_set_int(filter.params.width, filter.width)
	obs.gs_effect_set_int(filter.params.height, filter.height)
    --obs.gs_effect_set_float(filter.params.time, filter.time)

	obs.gs_blend_state_push()
	obs.gs_blend_function(obs.GS_BLEND_ONE, obs.GS_BLEND_INVSRCALPHA)
    obs.obs_source_process_filter_end(filter.source, filter.effect, filter.width, filter.height)
	obs.gs_blend_state_pop()
end

source_info.video_tick = function(filter, seconds)
    set_render_size(filter)
end

--obs.obs_register_source(source_info)

shader = [[
uniform float4x4 ViewProj;
uniform texture2d image;

uniform float ShadR;
uniform float ShadG;
uniform float ShadB;
uniform float ShadP;
uniform float MidR;
uniform float MidG;
uniform float MidB;
uniform float MidP;
uniform float HighR;
uniform float HighG;
uniform float HighB;
uniform float HighP;
uniform float SAT;
uniform bool PresLum;
uniform bool graph;
uniform int width;
uniform int height;

sampler_state textureSampler {
    Filter    = Linear;
    AddressU  = Clamp;
    AddressV  = Clamp;
};

struct VertDataIn {
    float4 pos : POSITION;
    float2 uv  : TEXCOORD0;
};

struct VertDataOut {
    float4 pos : POSITION;
    float2 uv  : TEXCOORD0;
};

VertDataOut VSDefault(VertDataIn v_in)
{
    VertDataOut vert_out;
    vert_out.pos = mul(float4(v_in.pos.xyz, 1.0), ViewProj);
    vert_out.uv  = v_in.uv;
    return vert_out;
}

float rgb_to_sat( float r, float g, float b)
{
float sat = 0.0f;
float mini = min(min(r, g), b);
float maxi = max(max(r, g), b);
float delta = maxi - mini;
if (maxi != 0.0f) sat = delta / maxi;
return sat;
}

float interpolateCubicHermite(float x, float3 xbp, float3 ybp) {
	float ax[5]; // = {0.0, xbp.x, xbp.y, xbp.z, 1.0};
	ax[0] = 0.0;
	ax[1] = xbp.x;
	ax[2] = xbp.y;
	ax[3] = xbp.z;
	ax[4] = 1.0;
	float ay[5]; // = {0.0, ybp.x, ybp.y, ybp.z, 0.0};
	ay[0] = 0.0;
	ay[1] = ybp.x;
	ay[2] = ybp.y;
	ay[3] = ybp.z;
	ay[4] = 0.0;
	float m[5];
	float delta[4];
	int k;

	for (k = 0; k < 4; k++) {
		float deltak = (ay[k+1] - ay[k]) / (ax[k+1] - ax[k]);
		delta[k] = deltak;
		if (k == 0) {
			m[k] = deltak;
		} else {
		float p = ((ax[k+1] - ax[k]) * delta[k-1] + (ax[k] - ax[k-1]) * deltak) / (ax[k+1] - ax[k-1]);
		m[k] = (sign(delta[k-1]) + sign(deltak)) * min(abs(delta[k-1]), min(abs(deltak), 0.5 * abs(p)));
		}
	}
	m[4] = delta[3];

	float c[4];
	float d[4];
	float xdiff;
	for (k=0; k < 4; k++) {
		xdiff = ax[k+1] - ax[k];
		c[k] = (3.0*delta[k] - 2.0*m[k] - m[k+1]) / xdiff;
		d[k] = (m[k] + m[k+1] - 2.0*delta[k]) / xdiff / xdiff;
	}
	k = 0;
	if (x >= ax[1] && x < ax[2]) k = 1;
	if (x >= ax[2] && x < ax[3]) k = 2;
	if (x >= ax[3] && x < ax[4]) k = 3;
	if (x >= ax[4]) k = 4;
	xdiff = x - ax[k];
	return ay[k] + m[k] * xdiff + c[k] * xdiff * xdiff + d[k] * xdiff * xdiff * xdiff;
}

float4 PassThrough(VertDataOut v_in) : TARGET
{

float4 rgba = image.Sample(textureSampler, v_in.uv);
float iwidth = float(width);
float iheight = float(height);
float pixX = 1.0 / iwidth;
float pixY = 1.0 / iheight;
float X = v_in.uv.x;
float Y = v_in.uv.y;
Y = 1.0 - Y;

float Sat = rgb_to_sat(rgba.r, rgba.g, rgba.b);
float lumaIn = (rgba.r + rgba.g + rgba.b) / 3.0f;
float3 RGB = float3(rgba.r, rgba.g, rgba.b);
float3 RGB1 = float3(X, X, X);

float L_Shad = ShadP / 255.0;
float L_Mid = MidP / 255.0;
float L_High = HighP / 255;

float3 parrayX = float3(L_Shad, L_Mid, L_High);
float3 rarY = float3(ShadR, MidR, HighR);
float3 garY = float3(ShadG, MidG, HighG);
float3 barY = float3(ShadB, MidB, HighB);

float3 COLR;
COLR.r = interpolateCubicHermite(RGB.r, parrayX, rarY);
COLR.g = interpolateCubicHermite(RGB.g, parrayX, garY);
COLR.b = interpolateCubicHermite(RGB.b, parrayX, barY);

float3 COLR1;
COLR1.r = interpolateCubicHermite(X, parrayX, rarY);
COLR1.g = interpolateCubicHermite(X, parrayX, garY);
COLR1.b = interpolateCubicHermite(X, parrayX, barY);

RGB = COLR + RGB;
RGB.rgb = saturate(RGB.rgb);

RGB1 = COLR1;
RGB = Sat <= SAT ? RGB : float3(rgba.r, rgba.g, rgba.b);

if(PresLum) {
	float lumaOut = (RGB.r + RGB.g + RGB.b) / 3.0;
	float lumaDiff = lumaIn / lumaOut;
	if(lumaIn > 0.0f && lumaOut > 0.0f) RGB.rgb = RGB.rgb * lumaDiff;
}

if (graph) {
	float3 Graph = float3(0.0, 0.0, 0.0);
	float overlayR, overlayG, overlayB;
	overlayR = COLR1.r + 0.5 >= (Y - pixY) && COLR1.r + 0.5 <= (Y + pixY) ? 1.0f : 0.0f;
	overlayG = COLR1.g + 0.5 >= (Y - pixY) && COLR1.g + 0.5 <= (Y + pixY) ? 1.0f : 0.0f;
	overlayB = COLR1.b + 0.5 >= (Y - pixY) && COLR1.b + 0.5 <= (Y + pixY) ? 1.0f : 0.0f;
	Graph = float3(overlayR, overlayG, overlayB);
	RGB = lerp(RGB.rgb, Graph, max(overlayR, max(overlayG, overlayB)));
}

return float4(RGB, rgba.a);
}

technique Draw
{
    pass
    {
        vertex_shader = VSDefault(v_in);
        pixel_shader  = PassThrough(v_in);
    }

}
]]
